//
// Board.java
// Autogenerated by Plank (https://pinterest.github.io/plank/)
//
// DO NOT EDIT - EDITS WILL BE OVERWRITTEN
// @generated
//

package com.pinterest.models;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import com.google.gson.Gson;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.annotations.SerializedName;
import com.google.gson.reflect.TypeToken;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonToken;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.Date;
import java.util.Map;
import java.util.Objects;
import java.util.Set;

public class Board {

    public static final String TYPE = "board";

    @SerializedName("id") private @Nullable String uid;
    @SerializedName("contributors") private @Nullable Set<User> contributors;
    @SerializedName("counts") private @Nullable Map<String, Integer> counts;
    @SerializedName("created_at") private @Nullable Date createdAt;
    @SerializedName("creator") private @Nullable Map<String, String> creator;
    @SerializedName("creator_url") private @Nullable String creatorURL;
    @SerializedName("description") private @Nullable String description;
    @SerializedName("image") private @NonNull Image image;
    @SerializedName("name") private @Nullable String name;
    @SerializedName("url") private @Nullable String url;

    private static final int ID_INDEX = 0;
    private static final int CONTRIBUTORS_INDEX = 1;
    private static final int COUNTS_INDEX = 2;
    private static final int CREATED_AT_INDEX = 3;
    private static final int CREATOR_INDEX = 4;
    private static final int CREATOR_URL_INDEX = 5;
    private static final int DESCRIPTION_INDEX = 6;
    private static final int IMAGE_INDEX = 7;
    private static final int NAME_INDEX = 8;
    private static final int URL_INDEX = 9;

    private boolean[] _bits;

    private Board(
        @Nullable String uid,
        @Nullable Set<User> contributors,
        @Nullable Map<String, Integer> counts,
        @Nullable Date createdAt,
        @Nullable Map<String, String> creator,
        @Nullable String creatorURL,
        @Nullable String description,
        @NonNull Image image,
        @Nullable String name,
        @Nullable String url,
        boolean[] _bits
    ) {
        this.uid = uid;
        this.contributors = contributors;
        this.counts = counts;
        this.createdAt = createdAt;
        this.creator = creator;
        this.creatorURL = creatorURL;
        this.description = description;
        this.image = image;
        this.name = name;
        this.url = url;
        this._bits = _bits;
    }

    @NonNull
    public static Board.Builder builder() {
        return new Board.Builder();
    }

    @NonNull
    public Board.Builder toBuilder() {
        return new Board.Builder(this);
    }

    @NonNull
    public Board mergeFrom(@NonNull Board model) {
        Board.Builder builder = this.toBuilder();
        builder.mergeFrom(model);
        return builder.build();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Board that = (Board) o;
        return Objects.equals(this.uid, that.uid) &&
        Objects.equals(this.contributors, that.contributors) &&
        Objects.equals(this.counts, that.counts) &&
        Objects.equals(this.createdAt, that.createdAt) &&
        Objects.equals(this.creator, that.creator) &&
        Objects.equals(this.creatorURL, that.creatorURL) &&
        Objects.equals(this.description, that.description) &&
        Objects.equals(this.image, that.image) &&
        Objects.equals(this.name, that.name) &&
        Objects.equals(this.url, that.url);
    }

    @Override
    public int hashCode() {
        return Objects.hash(uid,
        contributors,
        counts,
        createdAt,
        creator,
        creatorURL,
        description,
        image,
        name,
        url);
    }

    public @Nullable String getUid() {
        return this.uid;
    }

    public @Nullable Set<User> getContributors() {
        return this.contributors;
    }

    public @Nullable Map<String, Integer> getCounts() {
        return this.counts;
    }

    public @Nullable Date getCreatedAt() {
        return this.createdAt;
    }

    public @Nullable Map<String, String> getCreator() {
        return this.creator;
    }

    public @Nullable String getCreatorURL() {
        return this.creatorURL;
    }

    public @Nullable String getDescription() {
        return this.description;
    }

    public @NonNull Image getImage() {
        return this.image;
    }

    public @Nullable String getName() {
        return this.name;
    }

    public @Nullable String getUrl() {
        return this.url;
    }

    public boolean getUidIsSet() {
        return this._bits.length > ID_INDEX && this._bits[ID_INDEX];
    }

    public boolean getContributorsIsSet() {
        return this._bits.length > CONTRIBUTORS_INDEX && this._bits[CONTRIBUTORS_INDEX];
    }

    public boolean getCountsIsSet() {
        return this._bits.length > COUNTS_INDEX && this._bits[COUNTS_INDEX];
    }

    public boolean getCreatedAtIsSet() {
        return this._bits.length > CREATED_AT_INDEX && this._bits[CREATED_AT_INDEX];
    }

    public boolean getCreatorIsSet() {
        return this._bits.length > CREATOR_INDEX && this._bits[CREATOR_INDEX];
    }

    public boolean getCreatorURLIsSet() {
        return this._bits.length > CREATOR_URL_INDEX && this._bits[CREATOR_URL_INDEX];
    }

    public boolean getDescriptionIsSet() {
        return this._bits.length > DESCRIPTION_INDEX && this._bits[DESCRIPTION_INDEX];
    }

    public boolean getImageIsSet() {
        return this._bits.length > IMAGE_INDEX && this._bits[IMAGE_INDEX];
    }

    public boolean getNameIsSet() {
        return this._bits.length > NAME_INDEX && this._bits[NAME_INDEX];
    }

    public boolean getUrlIsSet() {
        return this._bits.length > URL_INDEX && this._bits[URL_INDEX];
    }

    public static class Builder {

        private @Nullable String uid;
        private @Nullable Set<User> contributors;
        private @Nullable Map<String, Integer> counts;
        private @Nullable Date createdAt;
        private @Nullable Map<String, String> creator;
        private @Nullable String creatorURL;
        private @Nullable String description;
        private @NonNull Image image;
        private @Nullable String name;
        private @Nullable String url;

        private boolean[] _bits;

        private Builder() {
            this._bits = new boolean[10];
        }

        private Builder(@NonNull Board model) {
            this.uid = model.uid;
            this.contributors = model.contributors;
            this.counts = model.counts;
            this.createdAt = model.createdAt;
            this.creator = model.creator;
            this.creatorURL = model.creatorURL;
            this.description = model.description;
            this.image = model.image;
            this.name = model.name;
            this.url = model.url;
            this._bits = model._bits;
        }

        @NonNull
        public Builder setUid(@Nullable String value) {
            this.uid = value;
            if (this._bits.length > ID_INDEX) {
                this._bits[ID_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setContributors(@Nullable Set<User> value) {
            this.contributors = value;
            if (this._bits.length > CONTRIBUTORS_INDEX) {
                this._bits[CONTRIBUTORS_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setCounts(@Nullable Map<String, Integer> value) {
            this.counts = value;
            if (this._bits.length > COUNTS_INDEX) {
                this._bits[COUNTS_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setCreatedAt(@Nullable Date value) {
            this.createdAt = value;
            if (this._bits.length > CREATED_AT_INDEX) {
                this._bits[CREATED_AT_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setCreator(@Nullable Map<String, String> value) {
            this.creator = value;
            if (this._bits.length > CREATOR_INDEX) {
                this._bits[CREATOR_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setCreatorURL(@Nullable String value) {
            this.creatorURL = value;
            if (this._bits.length > CREATOR_URL_INDEX) {
                this._bits[CREATOR_URL_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setDescription(@Nullable String value) {
            this.description = value;
            if (this._bits.length > DESCRIPTION_INDEX) {
                this._bits[DESCRIPTION_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setImage(@NonNull Image value) {
            this.image = value;
            if (this._bits.length > IMAGE_INDEX) {
                this._bits[IMAGE_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setName(@Nullable String value) {
            this.name = value;
            if (this._bits.length > NAME_INDEX) {
                this._bits[NAME_INDEX] = true;
            }
            return this;
        }

        @NonNull
        public Builder setUrl(@Nullable String value) {
            this.url = value;
            if (this._bits.length > URL_INDEX) {
                this._bits[URL_INDEX] = true;
            }
            return this;
        }

        public @Nullable String getUid() {
            return this.uid;
        }

        public @Nullable Set<User> getContributors() {
            return this.contributors;
        }

        public @Nullable Map<String, Integer> getCounts() {
            return this.counts;
        }

        public @Nullable Date getCreatedAt() {
            return this.createdAt;
        }

        public @Nullable Map<String, String> getCreator() {
            return this.creator;
        }

        public @Nullable String getCreatorURL() {
            return this.creatorURL;
        }

        public @Nullable String getDescription() {
            return this.description;
        }

        public @NonNull Image getImage() {
            return this.image;
        }

        public @Nullable String getName() {
            return this.name;
        }

        public @Nullable String getUrl() {
            return this.url;
        }

        @NonNull
        public Board build() {
            return new Board(
            this.uid,
            this.contributors,
            this.counts,
            this.createdAt,
            this.creator,
            this.creatorURL,
            this.description,
            this.image,
            this.name,
            this.url,
            this._bits
            );
        }

        public void mergeFrom(@NonNull Board model) {
            if (model._bits.length > ID_INDEX && model._bits[ID_INDEX]) {
                this.uid = model.uid;
                this._bits[ID_INDEX] = true;
            }
            if (model._bits.length > CONTRIBUTORS_INDEX && model._bits[CONTRIBUTORS_INDEX]) {
                this.contributors = model.contributors;
                this._bits[CONTRIBUTORS_INDEX] = true;
            }
            if (model._bits.length > COUNTS_INDEX && model._bits[COUNTS_INDEX]) {
                this.counts = model.counts;
                this._bits[COUNTS_INDEX] = true;
            }
            if (model._bits.length > CREATED_AT_INDEX && model._bits[CREATED_AT_INDEX]) {
                this.createdAt = model.createdAt;
                this._bits[CREATED_AT_INDEX] = true;
            }
            if (model._bits.length > CREATOR_INDEX && model._bits[CREATOR_INDEX]) {
                this.creator = model.creator;
                this._bits[CREATOR_INDEX] = true;
            }
            if (model._bits.length > CREATOR_URL_INDEX && model._bits[CREATOR_URL_INDEX]) {
                this.creatorURL = model.creatorURL;
                this._bits[CREATOR_URL_INDEX] = true;
            }
            if (model._bits.length > DESCRIPTION_INDEX && model._bits[DESCRIPTION_INDEX]) {
                this.description = model.description;
                this._bits[DESCRIPTION_INDEX] = true;
            }
            if (model._bits.length > IMAGE_INDEX && model._bits[IMAGE_INDEX]) {
                this.image = model.image;
                this._bits[IMAGE_INDEX] = true;
            }
            if (model._bits.length > NAME_INDEX && model._bits[NAME_INDEX]) {
                this.name = model.name;
                this._bits[NAME_INDEX] = true;
            }
            if (model._bits.length > URL_INDEX && model._bits[URL_INDEX]) {
                this.url = model.url;
                this._bits[URL_INDEX] = true;
            }
        }
    }

    public static class BoardTypeAdapterFactory implements TypeAdapterFactory {

        @Nullable
        @Override
        public <T> TypeAdapter<T> create(@NonNull Gson gson, @NonNull TypeToken<T> typeToken) {
            if (!Board.class.isAssignableFrom(typeToken.getRawType())) {
                return null;
            }
            return (TypeAdapter<T>) new BoardTypeAdapter(gson);
        }
    }

    private static class BoardTypeAdapter extends TypeAdapter<Board> {

        private final Gson gson;
        private TypeAdapter<Date> dateTypeAdapter;
        private TypeAdapter<Image> imageTypeAdapter;
        private TypeAdapter<Map<String, Integer>> map_String__Integer_TypeAdapter;
        private TypeAdapter<Map<String, String>> map_String__String_TypeAdapter;
        private TypeAdapter<Set<User>> set_User_TypeAdapter;
        private TypeAdapter<String> stringTypeAdapter;

        BoardTypeAdapter(Gson gson) {
            this.gson = gson;
        }

        @Override
        public void write(@NonNull JsonWriter writer, Board value) throws IOException {
            if (value == null) {
                writer.nullValue();
                return;
            }
            writer.beginObject();
            if (value._bits.length > ID_INDEX && value._bits[ID_INDEX]) {
                if (this.stringTypeAdapter == null) {
                    this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                }
                this.stringTypeAdapter.write(writer.name("id"), value.uid);
            }
            if (value._bits.length > CONTRIBUTORS_INDEX && value._bits[CONTRIBUTORS_INDEX]) {
                if (this.set_User_TypeAdapter == null) {
                    this.set_User_TypeAdapter = this.gson.getAdapter(new TypeToken<Set<User>>(){}).nullSafe();
                }
                this.set_User_TypeAdapter.write(writer.name("contributors"), value.contributors);
            }
            if (value._bits.length > COUNTS_INDEX && value._bits[COUNTS_INDEX]) {
                if (this.map_String__Integer_TypeAdapter == null) {
                    this.map_String__Integer_TypeAdapter = this.gson.getAdapter(new TypeToken<Map<String, Integer>>(){}).nullSafe();
                }
                this.map_String__Integer_TypeAdapter.write(writer.name("counts"), value.counts);
            }
            if (value._bits.length > CREATED_AT_INDEX && value._bits[CREATED_AT_INDEX]) {
                if (this.dateTypeAdapter == null) {
                    this.dateTypeAdapter = this.gson.getAdapter(Date.class).nullSafe();
                }
                this.dateTypeAdapter.write(writer.name("created_at"), value.createdAt);
            }
            if (value._bits.length > CREATOR_INDEX && value._bits[CREATOR_INDEX]) {
                if (this.map_String__String_TypeAdapter == null) {
                    this.map_String__String_TypeAdapter = this.gson.getAdapter(new TypeToken<Map<String, String>>(){}).nullSafe();
                }
                this.map_String__String_TypeAdapter.write(writer.name("creator"), value.creator);
            }
            if (value._bits.length > CREATOR_URL_INDEX && value._bits[CREATOR_URL_INDEX]) {
                if (this.stringTypeAdapter == null) {
                    this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                }
                this.stringTypeAdapter.write(writer.name("creator_url"), value.creatorURL);
            }
            if (value._bits.length > DESCRIPTION_INDEX && value._bits[DESCRIPTION_INDEX]) {
                if (this.stringTypeAdapter == null) {
                    this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                }
                this.stringTypeAdapter.write(writer.name("description"), value.description);
            }
            if (value._bits.length > IMAGE_INDEX && value._bits[IMAGE_INDEX]) {
                if (this.imageTypeAdapter == null) {
                    this.imageTypeAdapter = this.gson.getAdapter(Image.class).nullSafe();
                }
                this.imageTypeAdapter.write(writer.name("image"), value.image);
            }
            if (value._bits.length > NAME_INDEX && value._bits[NAME_INDEX]) {
                if (this.stringTypeAdapter == null) {
                    this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                }
                this.stringTypeAdapter.write(writer.name("name"), value.name);
            }
            if (value._bits.length > URL_INDEX && value._bits[URL_INDEX]) {
                if (this.stringTypeAdapter == null) {
                    this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                }
                this.stringTypeAdapter.write(writer.name("url"), value.url);
            }
            writer.endObject();
        }

        @Nullable
        @Override
        public Board read(@NonNull JsonReader reader) throws IOException {
            if (reader.peek() == JsonToken.NULL) {
                reader.nextNull();
                return null;
            }
            Builder builder = Board.builder();
            reader.beginObject();
            while (reader.hasNext()) {
                String name = reader.nextName();
                switch (name) {
                    case ("id"):
                        if (this.stringTypeAdapter == null) {
                            this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                        }
                        builder.setUid(this.stringTypeAdapter.read(reader));
                        break;
                    case ("contributors"):
                        if (this.set_User_TypeAdapter == null) {
                            this.set_User_TypeAdapter = this.gson.getAdapter(new TypeToken<Set<User>>(){}).nullSafe();
                        }
                        builder.setContributors(this.set_User_TypeAdapter.read(reader));
                        break;
                    case ("counts"):
                        if (this.map_String__Integer_TypeAdapter == null) {
                            this.map_String__Integer_TypeAdapter = this.gson.getAdapter(new TypeToken<Map<String, Integer>>(){}).nullSafe();
                        }
                        builder.setCounts(this.map_String__Integer_TypeAdapter.read(reader));
                        break;
                    case ("created_at"):
                        if (this.dateTypeAdapter == null) {
                            this.dateTypeAdapter = this.gson.getAdapter(Date.class).nullSafe();
                        }
                        builder.setCreatedAt(this.dateTypeAdapter.read(reader));
                        break;
                    case ("creator"):
                        if (this.map_String__String_TypeAdapter == null) {
                            this.map_String__String_TypeAdapter = this.gson.getAdapter(new TypeToken<Map<String, String>>(){}).nullSafe();
                        }
                        builder.setCreator(this.map_String__String_TypeAdapter.read(reader));
                        break;
                    case ("creator_url"):
                        if (this.stringTypeAdapter == null) {
                            this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                        }
                        builder.setCreatorURL(this.stringTypeAdapter.read(reader));
                        break;
                    case ("description"):
                        if (this.stringTypeAdapter == null) {
                            this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                        }
                        builder.setDescription(this.stringTypeAdapter.read(reader));
                        break;
                    case ("image"):
                        if (this.imageTypeAdapter == null) {
                            this.imageTypeAdapter = this.gson.getAdapter(Image.class).nullSafe();
                        }
                        builder.setImage(this.imageTypeAdapter.read(reader));
                        break;
                    case ("name"):
                        if (this.stringTypeAdapter == null) {
                            this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                        }
                        builder.setName(this.stringTypeAdapter.read(reader));
                        break;
                    case ("url"):
                        if (this.stringTypeAdapter == null) {
                            this.stringTypeAdapter = this.gson.getAdapter(String.class).nullSafe();
                        }
                        builder.setUrl(this.stringTypeAdapter.read(reader));
                        break;
                    default:
                        reader.skipValue();
                        break;
                }
            }
            reader.endObject();
            return builder.build();
        }
    }
}
